CONST   {EBCDIC TO ASCII TRANSLATE TABLE}
   ETOA: ARRAY[0..255] OF BYTE = (

         $00,$01,$02,$03,  {  NUL  SOH  ETX  STX        0     0  }
         $00,$09,$00,$7F,  {       HT                   4     4  }
         $00,$00,$00,$0B,  {                 VT         8     8  }
         $0C,$0D,$0E,$0F,  {  FF   CR   SO   SI         12    C  }
         $10,$11,$12,$00,  {  DLE  DC1  DC2             16    10 }
         $00,$13,$08,$00,  {       DC3  BS              20    14 }
         $18,$19,$00,$00,  {  CAN  EM                   24    28 }
         $1C,$1D,$1E,$1F,  {  IFS  IGS  IRS  IUS        28    1C }
         $00,$00,$1C,$00,  {            FS              32    20 }
         $00,$0A,$17,$1B,  {                            36    40 }
         $00,$00,$00,$00,  {                            40    28 }
         $00,$05,$06,$07,  {       ENQ  ACK  BEL        44    2C }
         $00,$00,$16,$00,  {            SYN             48    30 }
         $00,$1E,$00,$04,  {       RS        EOT        52    34 }
         $00,$00,$00,$00,  {                            56    38 }
         $14,$15,$00,$1A,  {  DC4  NAK       SUB        60    3C }
         $20,$00,$00,$00,  {  SP                        64    40 }
         $00,$00,$00,$00,  {                            68    44 }
         $00,$00,$00,$2E,  {                 .          72    48 }
         $3C,$28,$2B,$5E,  {  <    (    +               76    4C }
         $26,$00,$00,$00,  {  &                         80    50 }
         $00,$00,$00,$00,  {                            84    54 }
         $00,$00,$21,$24,  {            !    $          88    58 }
         $2A,$29,$3B,$5E,  {       )    ;    ^          92    5C }
         $2D,$2F,$00,$00,  {  -    /                    96    60 }
         $00,$00,$00,$00,  {                            100   64 }
         $00,$00,$7C,$2C,  {                            104   68 }
         $25,$5F,$3E,$3F,  {  %         >     ?         108   6C }
         $00,$00,$00,$00,  {                            112   70 }
         $00,$00,$00,$00,  {                            116   74 }
         $00,$60,$3A,$23,  {            :     #         120   78 }
         $40,$27,$3D,$22,  {  @         =     "         124   7C }
         $00,$61,$62,$63,  {  -    A    B     C         128   80 }
         $64,$65,$66,$67,  {  D    E    F     G         132   84 }
         $68,$69,$00,$00,  {  H    I                    136   88 }
         $00,$00,$00,$00,  {                            140   8C }
         $00,$6A,$6B,$6C,  {       J    K     L         144   90 }
         $6D,$6E,$6F,$70,  {  M    N    O     P         148   94 }
         $71,$72,$00,$00,  {  Q    R                    152   98 }
         $00,$00,$00,$00,  {                            156   9C }
         $00,$7E,$73,$74,  {            S     T         160   A0 }
         $75,$76,$77,$78,  {  U    V    W     X         164   A4 }
         $79,$7A,$00,$00,  {  Y    Z                    168   A8 }
         $00,$5B,$00,$00,  {                            172   AC }
         $00,$00,$00,$00,  {                            176   B0 }
         $00,$00,$00,$00,  {                            180   B4 }
         $00,$00,$00,$00,  {                            184   B8 }
         $00,$5D,$00,$00,  {                            188   BC }
         $7B,$41,$42,$43,  {       A    B    C          192   C0 }
         $44,$45,$46,$47,  {  D    E    F    G          196   C4 }
         $48,$49,$00,$00,  {                            200   C8 }
         $00,$00,$00,$00,  {                            204   CC }
         $7D,$4A,$4B,$4C,  {       J    K    L          208   D0 }
         $4D,$4E,$4F,$50,  {  M    N    O     P         212   D4 }
         $51,$52,$00,$00,  {  Q    R                    216   D8 }
         $00,$00,$00,$00,  {                            220   DC }
         $5C,$00,$53,$54,  {            S    T          224   E0 }
         $55,$56,$57,$58,  {  U    V    W    X          228   E4 }
         $59,$5A,$00,$00,  {  Y    Z                    232   E8 }
         $00,$00,$00,$00,  {                            236   EC }
         $30,$31,$32,$33,  {  0    1    2    3          240   F0 }
         $34,$35,$36,$37,  {  4    5    6    7          244   F4 }
         $38,$39,$00,$00,  {  8    9                    248   F8 }
         $00,$00,$00,$00); {                            252   FC }

CONST    {ASCII TO EBCDIC TO ASCII TRANSLATE TABLE ENTRIES 128-255 ARE
          ASCII CHARACTERS WITH PARITY SET TO 1}
   ATOE: ARRAY[0..255] OF BYTE = (

         $00,$01,$02,$03,  {  NUL  SOH  STX  ETX        00    00 }
         $37,$2D,$2E,$2F,  {  EOT  ENQ  ACK  BEL        04    04 }
         $16,$05,$25,$0B,  {  BS   HT   LF   VT         08    08 }
         $0C,$0D,$0E,$0F,  {  FF   CR   SO   SI         12    0C }
         $10,$11,$12,$15,  {  DLE  DC1  DC2  DC3(NL)    16    10 }
         $3C,$3D,$32,$26,  {  DC4  NAK  SYN  ETB        20    14 }
         $18,$19,$3F,$27,  {  CAN  EM   SUB  ESC        24    18 }
         $1C,$1D,$1E,$1F,  {  FS   GS   RS   US         28    1C }
         $40,$5A,$7F,$7B,  {  SP   !    "    #          32    24 }
         $5B,$6C,$50,$7D,  {  $    %   &                36    24 }
         $4D,$5D,$5C,$4E,  {  (    )         +          40    28 }
         $6B,$60,$4B,$61,  {  ,    -    .    /          44    2C }
         $F0,$F1,$F2,$F3,  {  0    1    2    3          48    30 }
         $F4,$F5,$F6,$F7,  {  4    5    6    7          52    34 }
         $F8,$F9,$7A,$5E,  {  8    9    :    ;          56    38 }
         $4C,$7E,$6E,$6F,  {  <    =    >    ?          60    3C }
         $7C,$C1,$C2,$C3,  {  @    A    B    C          64    40 }
         $C4,$C5,$C6,$C7,  {  D    E    F    G          68    44 }
         $C8,$C9,$D1,$D2,  {  H    I    J    K          72    48 }
         $D3,$D4,$D5,$D6,  {  L    M    N    0          76    4C }
         $D7,$D8,$D9,$E2,  {  P    Q    R    S          80    50 }
         $E3,$E4,$E5,$E6,  {  T    U    V    W          84    54 }
         $E7,$E8,$E9,$AD,  {  X    Y    Z SQU BRAC      88    58 }
         $E0,$BD,$5F,$6D,  {                            92    5C }
         $79,$81,$82,$83,  {       A    B    C          96    60 }
         $84,$85,$86,$87,  {  D    E    F    G          100   64 }
         $88,$89,$91,$92,  {  H    I    J    K          104   68 }
         $93,$94,$95,$96,  {  L    M    N    O          108   6C }
         $97,$98,$99,$A2,  {  P    Q    R    S          112   70 }
         $A3,$A4,$A5,$A6,  {  T    U    V    W          116   74 }
         $A7,$A8,$A9,$C0,  {  X    Y    Z               120   78 }
         $6A,$D0,$A1,$07,  {                            124   7C }
         $00,$01,$02,$03,  {  NUL  SOH  STX  ETX        00    00 }
         $37,$2D,$2E,$2F,  {  EOT  ENQ  ACK  BEL        04    04 }
         $16,$05,$25,$0B,  {  BS   HT   LF   VT         08    08 }
         $0C,$0D,$0E,$0F,  {  FF   CR   SO   SI         12    0C }
         $10,$11,$12,$15,  {  DLE  DC1  DC2  DC3(NL)    16    10 }
         $3C,$3D,$32,$26,  {  DC4  NAK  SYN  ETB        20    14 }
         $18,$19,$3F,$27,  {  CAN  EM   SUB  ESC        24    18 }
         $1C,$1D,$1E,$1F,  {  FS   GS   RS   US         28    1C }
         $40,$5A,$7F,$7B,  {  SP   !    "    #          32    24 }
         $5B,$6C,$50,$7D,  {  $    %   &                36    24 }
         $4D,$5D,$5C,$4E,  {  (    )         +          40    28 }
         $6B,$60,$4B,$61,  {  ,    -    .    /          44    2C }
         $F0,$F1,$F2,$F3,  {  0    1    2    3          48    30 }
         $F4,$F5,$F6,$F7,  {  4    5    6    7          52    34 }
         $F8,$F9,$7A,$5E,  {  8    9    :    ;          56    38 }
         $4C,$7E,$6E,$6F,  {  <    =    >    ?          60    3C }
         $7C,$C1,$C2,$C3,  {  @    A    B    C          64    40 }
         $C4,$C5,$C6,$C7,  {  D    E    F    G          68    44 }
         $C8,$C9,$D1,$D2,  {  H    I    J    K          72    48 }
         $D3,$D4,$D5,$D6,  {  L    M    N    0          76    4C }
         $D7,$D8,$D9,$E2,  {  P    Q    R    S          80    50 }
         $E3,$E4,$E5,$E6,  {  T    U    V    W          84    54 }
         $E7,$E8,$E9,$AD,  {  X    Y    Z SQU BRAC      88    58 }
         $E0,$BD,$5F,$6D,  {                            92    5C }
         $79,$81,$82,$83,  {       A    B    C          96    60 }
         $84,$85,$86,$87,  {  D    E    F    G          100   64 }
         $88,$89,$91,$92,  {  H    I    J    K          104   68 }
         $93,$94,$95,$96,  {  L    M    N    O          108   6C }
         $97,$98,$99,$A2,  {  P    Q    R    S          112   70 }
         $A3,$A4,$A5,$A6,  {  T    U    V    W          116   74 }
         $A7,$A8,$A9,$C0,  {  X    Y    Z               120   78 }
         $6A,$D0,$A1,$07); {                            124   7C }
